<template>
  <v-dialog v-model="dialogRank" @click:outside="close" max-width="50%">
    <v-card class="pa-8">
      <v-card-title class="justify-center text-h5 d-flex font-weight-bold">
        {{ dialogTitle }}
      </v-card-title>
      <v-divider class="mt-2 mb-6"></v-divider>

      <AdminRanksRankForm :rank="rank" />

      <v-card-actions class="justify-center d-flex">
        <v-btn variant="outlined" rounded size="large" class="text-uppercase" data-cy="RankFormCancelBtn" @click="close()">
          Annuler
        </v-btn>
        <v-btn variant="outlined" rounded size="large" :disabled="!meta.valid" class="text-uppercase inverted" data-cy="RankFormOkBtn"
          :loading="loading" @click="confirm()">
          Valider
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { Rank } from "~/dto/rank.dto";

const dialogRank = defineModel<boolean>();

const props = defineProps<{ rank: Rank }>();

const emit = defineEmits(['close', 'confirm']);

const { validate, meta } = useForm({
  initialValues: props.rank
})

const dialogTitle = ref(props.rank.id ? `Édition d'un grade` : `Création d'un grade`);
const loading = ref(false);
const form: Ref<any> = ref(null);

const close = () => {
  emit('close');
};

const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  emit('confirm');
  loading.value = true;
};
</script>
